<script setup lang="ts">
import { useRouter } from "vue-router";
// import { login } from "@/auth/jwtService";
import { Ref, computed, reactive } from "vue";
import { toast } from "vue3-toastify";
// import { setAccessToken } from "@/auth/jwtService";
// import { setRefreshToken } from "@/auth/jwtService";
import ability from "@/plugins/casl/ability";
import useVuelidate, { Validation } from "@vuelidate/core";
import { required, helpers } from "@vuelidate/validators";

interface Login {
  phone: string;
  password: string;
}

const router = useRouter();
let formData = reactive<Login>({
  phone: "998914611305",
  password: "Qwerty1@",
});

const rules = computed(() => {
  return {
    phone: {
      required: helpers.withMessage(
        "Это поля обязательно для заполнения",
        required
      ),
    },
    password: {
      required: helpers.withMessage(
        "Это поля обязательно для заполнения",
        required
      ),
    },
  };
});
const validate: Ref<Validation> = useVuelidate(rules, formData);

const validationForm = async () => {
  const success = await validate.value.$validate();
  if (!success) return;

  try {
    const sendData = JSON.parse(JSON.stringify(formData));
    sendData.phone = sendData.phone.replace(/\D/g, "");
    // const { data } = await login(sendData);
    // setAccessToken(data.access);
    // setRefreshToken(data.refresh);
    let userAbilities = [{ subject: "all", action: "manage" }];
    localStorage.setItem("userAbilities", JSON.stringify(userAbilities));
    ability.update(userAbilities);

    router.push("/forms");
    setTimeout(() => {
      toast.success("Success");
    }, 200);
  } catch (error: any) {
    toast.error(error.response.data.msg ? error.response.data.msg : "Error");
  }
};
</script>

<template>
  <div class="mx-auto flex w-full max-w-md items-center px-6 lg:w-2/6">
    <div class="flex-1">
      <div class="text-center">
        <h2 class="text-center text-4xl font-bold text-gray-700 dark:text-white">
          Войти
        </h2>
      </div>

      <div class="mt-8">
        <form @submit.prevent="validationForm">
          <div>
            <div class="flex justify-between">
              <label for="phone" class="text-sm text-gray-600 dark:text-gray-200">Номер телефона</label>
            </div>

            <input v-model="formData.phone" v-maska data-maska="+998 ## ### ## ##" id="phone" type="text" name="phone"
              placeholder="Your phone" class="form-input" />
            <p v-for="error in validate.phone.$errors" :key="error.$uid" class="whitespace-nowrap text-danger text-sm">
              {{ $t(error.$message) }}
            </p>
          </div>

          <div class="mt-6">
            <div class="flex justify-between">
              <label for="password" class="text-sm text-gray-600 dark:text-gray-200">Пароль</label>
            </div>

            <input v-model="formData.password" id="password" type="password" name="password" placeholder="Your Password"
              class="form-input" />
            <p class="whitespace-nowrap text-danger text-sm" v-for="error in validate.password.$errors" :key="error.$uid">
              {{ $t(error.$message) }}
            </p>
          </div>

          <div class="mt-12">
            <button type="submit" class="btn-primary w-full">Войти</button>
            <!-- <button
              type="button"
              class="btn-outline-primary w-full mt-2"
              @click="$router.push({ name: 'register' })"
            >
              Регистрация
            </button> -->
          </div>
        </form>

        <!-- <p
          class="mt-6 text-center text-sm text-gray-400 underline hover:text-blue-500 cursor-pointer"
        >
          Забыли пароль?
        </p> -->
      </div>
    </div>
  </div>
</template>
